<div id="wrapper">
  <agm-map [zoom]="mapProperties?.zoom"  [latitude]="mapProperties?.lat" [longitude]="mapProperties?.lng"
    (mapRightClick)="addWaypoint($event)" (mapReady)="onReady($event)" [minZoom]="mapProperties?.minZoom">
    <ng-container *ngIf="!nearbyMarkers.length">
      <agm-marker *ngFor="let data of markers" [iconUrl]="data.iconUrl" [latitude]="data?.lat" [longitude]="data?.lng"
        (markerClick)=markerClick(iw) [markerDraggable]="false" [openInfoWindow]="true">
        <agm-info-window #iw [disableAutoPan]="false" [maxWidth]="300" [isOpen]="isInfoWindowOpen(data)">
          <p>Address - {{data?.name || "N.A"}}</p>
          <p>District - {{data?.desc}}</p>
          <p>Availability - {{data?.availability}}</p>
          <p>
            <button *ngIf="data?.showNearby==true" class="btn" title="Nearby Places"
              (click)="showNearbyPlaces(data)">Show nearby places</button>
            <p>
        </agm-info-window>
      </agm-marker>
    </ng-container>

    <ng-container *ngIf="nearbyMarkers.length">
      <agm-marker *ngFor="let d of nearbyMarkers" [latitude]="d?.lat" [longitude]="d?.lng" [iconUrl]="d?.icon"
        [markerDraggable]="false" [openInfoWindow]="true">
        <agm-info-window [disableAutoPan]="false" [maxWidth]="300">
          <p><strong>{{d?.name}}</strong></p>
          <p>Address - {{d?.address}}</p>
          <p>Types - {{d?.types}}</p>
        </agm-info-window>
      </agm-marker>
    </ng-container>
    <div *ngIf="showDirection">
      <agm-marker *ngFor="let d of waypoints; let i=index" [latitude]="d?.location?.lat" [longitude]="d?.location?.lng"
        [markerDraggable]="true" [label]="getLabel(i)">
      </agm-marker>
      <agm-direction [origin]="origin" [waypoints]="waypoints" [provideRouteAlternatives]="true"
        [destination]="destination">
      </agm-direction>
    </div>

  </agm-map>
  <div class="row no-padding no-margin">
    <div id="floating-panel">
      <div [hidden]="nearbyMarkers.length">
        <div class="card">
          <div class="input-group">
            <input class="form-control" placeholder="Enter Employee Address" autocorrect="off" autocapitalize="off"
              spellcheck="off" type="text" class="form-control" #search [formControl]="searchControl">
            <span class="input-group-append">
              <button class="btn btn-outline-secondary" type="button">
                <i class="fa fa-search"></i>
              </button>
            </span>
          </div>
          <label>Radius (1-10kms)</label>
          <input class="form-control" type="range" min="1000" max="10000" [(ngModel)]="mapProperties.radius"
            (change)="getAllCoords()" class="slider" id="myRange">
          <p>Current Value {{mapProperties.radius/1000}}kms</p>
          <button class="btn" type="button" title="Clear Markers" (click)="clearMarkers()">Clear Markers</button>
          <button class="btn" type="button" title="Toggle Zones" (click)="toggleLayer(!showZones)">Toggle Layer</button>
        </div>
        <div class="card">
          <label>Origin</label>
          <div class="input-group">
            <input #orig class="form-control" [(ngModel)]="origin" placeholder="Enter Origin" type="text"
              class="form-control">
            <!-- <span class="input-group-append" (click)="updateAddress('o')">
              <button class="btn btn-outline-secondary" type="button">
                <i class="fa fa-check"></i>
              </button>
            </span> -->
          </div>
          <label>Destination</label>
          <div class="input-group">
            <input #dest class="form-control" [(ngModel)]="destination" placeholder="Enter Destination" type="text"
              class="form-control">
            <!-- <span class="input-group-append" (click)="updateAddress('d')">
              <button class="btn btn-outline-secondary" type="button">
                <i class="fa fa-check"></i>
              </button>
            </span> -->
          </div>
          <br>
          <a *ngIf="waypoints.length" style="float: right;" [href]="getMapLink()" target="_blank">Click here</a>
          <button class="btn" type="button" title="Clear Direction" (click)="clearWaypoints()">Clear Waypoints</button>
          <button class="btn" type="button" title="Toggle Direction" (click)="toggleDirection()">Toggle
            Direction</button>
        </div>
      </div>
      <div *ngIf="nearbyMarkers.length">
        <div class="card">
          <button class="btn" title="Go Back" (click)="backtoPoints()"><i class="fa fa-angle-double-left"
              aria-hidden="true"></i>Back</button>
        </div>
      </div>
    </div>
  </div>
</div>